```@meta
CurrentModule = Yao
```

# Yao

*A General Purpose Quantum Computation Simulation Framework*

Welcome to [Yao](https://github.com/QuantumBFS/Yao.jl), a **Flexible**, **Extensible**, **Efficient** Framework for
Quantum Algorithm Design. **Yao** (幺) is the Chinese character for unitary. It is also means the first (一) in Chinese
(it is the first released package from [QuantumBFS](https://github.com/QuantumBFS)).

We aim to provide a powerful tool for researchers, students to study and explore quantum computing in near term
future, before quantum computer being used in large-scale.

## Tutorial

```@contents
Pages = [
    "tutorial/GHZ.md",
    "tutorial/QFT.md",
    "tutorial/Grover.md",
    "tutorial/QCBM.md",
]
Depth = 1
```

## Manual

```@contents
Pages = [
    "man/interfaces.md",
    "man/registers.md",
    "man/blocks.md",
    "man/cache.md",
    "man/intrinsics.md",
    "man/luxurysparse.md",
]
Depth = 1
```
